
Form := function( p, j )
    local f, k, F;
    f := 2 * MutableIdentityMat( p-1 );
    for k in [1..p-2] do
        f[k][k+1] := -1;
        f[k+1][k] := -1;
    od;
    F := List( [1..p^(j-1)], x -> f );
    return DiagonalBlockMat( F );
end;

Cyclic := function( p, j )
    local x, f, m, l, i, I, J, K;
  
    # get c1
    x := Indeterminate( Rationals );
    f := Sum( List( [1..p], i -> x^(i-1) ) );
    m := CompanionMat( f );

    # get permutation
    l := MutableNullMat( p, p );
    for i in [1..p-1] do
        l[i][i+1] := 1;
    od;
    l[p][1] := 1; 
    
    # iterate Kronecker
    for i in [1..j-1] do
        I := IdentityMat( p^(i-1)*(p-1) );
        J := KroneckerProduct( l, I );
        K := List( [1..p-1], x -> I );
        Add( K, m );
        K := DiagonalBlockMat( K );
        m := K * J;
    od;
    return m;
end; 

IsFormOf := function( f, g )
    return TransposedMat(g) * f * g = f;
end;

