
#############################################################################
##
#F DrawClassTwoBranchSpecial( G, l )
##
PrintVertexSheetSpecial := function( Sheet, cl, nr, t, v )
    local x, y;

    # set up x and y values
    x := 100 + 25 * (nr-1);
    y := 70 + 40 * cl;

    # print data
    Disc( Sheet, x, y, 3 );
    if not IsBool(v) then 
      Line( Sheet, v[1], v[2], x-v[1], y-v[2] );
    fi;
    if not IsBool(t) then
        Text( Sheet, FONTS.small, x+2, y, String(t) );
    fi;

    # return place
    return [x, y];
end;

DrawClassTwoBranchSpecial := function( G, l, c )
    local p, s, d, n, t, a, T, A, U, V, W, pcp, grp, new, i, j, cl, CR, 
          tmp, com, g, v, title, wid; 

    # set up
    p := G!.prime;
    s := G!.param;
    d := p^(s-1)*(p-1);

    # get class two module
    t := Filtered(Igs(G), x -> RelativeOrder(x) = 0);
    a := t{[d+1..Length(t)]};
    T := SubgroupByIgs(G, t);
    A := SubgroupByIgs(G, a);
    n := Length(Igs(G)) - Length(t);

    # jump to some point in T/T' 
    U := T;
    G!.isNormal := true;
    while Index(G,U) < p^l do
        U := CommutatorSubgroup(G,U);
        U := SubgroupByIgsAndIgs( G, Igs(U), a );
    od;

    # set up graphic sheet
    title := Concatenation( "Branch for |G| = ", String(p), "^", String(n));
    Sheet := GraphicSheet( title, 1000, 1000 );
    PrintScaleSheetClassTwo( Sheet, p, l, 25 );

    grp := [[U,false]];
    V := A;
    i := 0;
    while Length(grp) > 0 do
        i := i + 1;
        j := 1;
        Print("layer ",i," with ",Length(grp)," groups to go \n");

        W := CommutatorSubgroup(G, V);
        pcp := Pcp(V,W);
        V := W;

        new := [];
        for cl in grp do
            CR := rec( group  := cl[1],
                       super  := Pcp(G, cl[1]),
                       factor := Pcp(cl[1], GroupOfPcp(pcp)),
                       normal := pcp );
            AddFieldCR(CR); AddRelatorsCR(CR); 
            AddOperationCR(CR); AddInversesCR(CR);

            # get G-invariant complements
            tmp := InvariantComplementsCR( CR );
            Print("    determined ",Length(tmp)," complements \n");

            ## reduce to isom-types
            com := IsomtypesFactors( G, tmp, G!.cocla );
            Print("  reduced to ",Length(com)," isom types \n");

            # draw groups
            for g in com do
                if i > c then
                    repeat
                        v := PrintVertexSheetSpecial(Sheet,i-c,j,g!.nr,cl[2]);
                        j := j + 1;
                    until not IsBool(v);
                    Add( new, [g, v] );
                else
                    Add( new, [g, false] );
                fi;
            od;
        od;
        grp := new;
    od;
end;
