#############################################################################
##
#W centext.gi                 Coclass package                    Bettina Eick
##

#############################################################################
##
#F CentralExtensions(G, s)
##
CentralExtensions := function( G, s )
    local mats, CR, exts, i;
    mats := List( Igs(G), x -> IdentityMat(s, GF(G!.prime)) );
    CR := CRRecordByMats( G, mats );
    exts := ExtensionClassesCR(CR);
    for i in [1..Length(exts)] do exts[i]!.prime := G!.prime; od;
    return exts;
end;

#############################################################################
##
#F ClassifyProPGroupByCoclass(p, s, all)
##
ClassifyProPGroupsByCoclass := function(p, s, all)
    local grps, new, tmp, G, i, j;

    if p = 2 then 
        grps := [[DihedralPcpGroup(0)]];
        grps[1][1]!.prime := 2;
        grps[1][1]!.param := 1;
    else
        grps := [ClassifySpaceGroups(1,p,1)];
    fi;

    for i in [2..s] do
        new := [];

        # central extensions if 'all' is true
        if all then
            for G in grps[i-1] do
                tmp := CentralExtensions( G, 1 );
                Append( new, tmp );
            od;
            if p > 2 then 
                new := DistinguishGroups( new, p, 2*p*(i+1) ); 
            fi;
        fi;

        # space groups
        if all = true or i = s then
            for j in [2..i] do
                tmp := ClassifySpaceGroups( j,p,i );
                tmp := Filtered(tmp, x -> x!.cclas=i);
                Append( new, tmp );
            od;
            if p = 2 then 
                new := DistinguishGroups( new, p, 4*p*(i+1) ); 
            fi;
        fi;

        grps[i] := new;
    od;

    # that's it
    if all = false then grps := grps[s]; fi;
    return grps;
end;

