TRANSLATE := true;

SpaceGroupsOfObliquity0 := function(s,p)
    local N, A, res, i, Ni, Gi, Ci, uni, len, j, t, cc, U, G, F, l;

    # get the maximal point group and the relevant actions
    Print("\npoint group \n");
    N := WreathFiniteNormalizer( s, p );

    # add lattices
    Print("\nlattices and fixed points \n");
    A := ActionRecord( N );

    # loop over centres
    res := [];
    for i in [0..s-1] do
 
        Print("\nset up for groups with centre ",i,"\n");
        Ni := WreathFiniteNormalizer( N, i );
        Gi := Ni!.pointgroup;
        Ci := WreathInfiniteCentralizer( Gi );
        AddActions( A, Ni, Ci );

        # get uniserial subgroups 
        Print("  compute uniserials \n");
        cc := Sum(List([0..s-1], x -> p^x));
        uni := UniserialSubgroupsByCentre( Ni, cc );

        # filter by obliquity
        for j in [1..Length(uni)] do
            U := SubgroupByIgs(N, uni[j].repr);
            if HasObliquity0(U) then 
                cc := Coclass(U);
                Print("    ",j,"th subgroup of ",Length(uni),"\n");
                t := CohomologiesOfPointGroup( N, A, uni[j], cc+1 );
                Add( res, t );
            fi;
        od;
    od;
    Print("\n");

    # set up results
    Print("set up ",Length(res)," extensions \n");
    res := Flat(res);
    res := List( res, x -> ExtensionOfPointGroup(N,A,x) );

    Print("filter extensions \n");
    for i in [1..Length(res)] do
        Print("filter extension ",i," \n");
        G := res[i];
        l := Length(Igs(G));
        F := G/LowerCentralSeries(G,l+1)[l+1];
        if not HasObliquity0(F) then res[i] := false; fi;
    od;
    return Filtered(res, x -> x <> false);
end;

