#############################################################################
##
#W  pcpgrp.gi                   Package Coclass                  Bettina Eick
##

#############################################################################
##
#F RumpDepth( U, p )
##
RumpDepth := function( U, p )
    return List( Igs(PRump(U,p)), Depth );
end;

#############################################################################
##
#F ElementsOfClass( G, N, U )
##
ElementsOfClass := function( G, N, U )
    local pcp, elm;
    pcp := Pcp(G, N);
    elm := ExponentsByRels( RelativeOrdersOfPcp(pcp) );
    elm := List( elm, x -> MappedVector( x, pcp ) );
    return List( elm, x -> U^x );
end;

#############################################################################
##
#F ElementsOfPcpGroup( G )
##
ElementsOfPcpGroup := function(G)
    local pcp, rel;
    pcp := Pcp(G);
    rel := ExponentsByRels( RelativeOrdersOfPcp( pcp ) );
    return List( rel, x -> MappedVector(x, pcp) );
end;

#############################################################################
##
#F RefinedCentralSeries(N, G)
##
RefinedCentralSeries := function(N, G)
    local p, S, U, C, pcp, mat, bas, b, tmp, fac;

    # set up
    U := G;
    p := PrimePGroup(G);
    G!.isNormal := true;
    fac := Pcp(N,G);

    # loop
    S := [G];
    while Size(U) > 1 do

        # get next layer
        C := CommutatorSubgroup( U, G );
        pcp := Pcp(U,C);
        mat := LinearActionOnPcp(fac,pcp) * One(GF(p));
        mat := GModuleByMats(mat, Length(pcp), GF(p));
        bas := SMTX.BasesCompositionSeries(mat);
        if Length(bas) <= Length(pcp) then Error("no series"); fi;
        
        # translate back
        for b in Reversed(bas{[1..Length(bas)-1]}) do
            tmp := List(b, x -> MappedVector(x, pcp));
            U := SubgroupByIgs( G, tmp, Igs(C) );
            Add( S, U );
        od;
    od;

    Unbind(G!.isNormal);
    return S;
end;


