
CyclicSplitGroup := function(n)
    local A, m, G;
    A := AbelianPcpGroup(1, [2^n]);
    m := [[-1]];
    G := SplitExtensionPcpGroup(A, [m]);
    return G;
end;

MetacyclicParameters := function( G )
    local p, a, n, o, r, s, D, d, g, U, c, z, y, f, t1, t2, t;

    G := PcGroupToPcpGroup(G);

    # two paras are easy
    p := PrimePGroup(G);
    a := AbelianInvariants(G);
    n := LogInt(Maximum(a), p);
    o := LogInt(Size(G), p);
    r := 2^(o-n);
    s := 2^n;

    # get normal subgroup
    D := DerivedSubgroup(G);
    d := GeneratorsOfGroup(D)[1];
    g := Pcp(G,D,"snf");
    
    # try for z
    U := Subgroup(G, [d, g[2]]);
    c := ComplementClasses(U,D);
    if Length(c) = 0 then 
        U := Subgroup(G, [d, g[1]*g[2]]);
        c := ComplementClasses(U,D);
    fi;
    if Length(c) > 0 then 
        z := Pcp(c[1].repr,"snf")[1];
        f := 0;
    else
        z := g[2];
        if Order(z) > 2^(n+1) then Error("wrong z"); fi; 
        f := r/2;
    fi;

    # try for y
    y := g[1]*g[2]^(s/2);
    t := First([0..r-1], x -> y*y^z = y^x );
    if t = fail then Error("conjugate wrong"); fi;
    t := (t-1)^s - 1;
    t := t/r; 
    if not IsInt(t) then Error("r not div"); fi;
    t := PadicValue(t, 2);

    #y := g[1]*g[2]^(2^(n-1));
    #t2 := First([0..r-1], x -> y*y^z = y^x );
    #t2 := PadicValue(((t2-1)^s-1)/r, 2);

    return rec( f := f, t := t);
end;

