
ReducedCentralExtensions := function( G )
    local p, mats, CR, cc, l, v, ext, i, H;
    p := G!.prime;
    mats := List( Igs( G ), x -> IdentityMat( 1, GF( p ) ) );
    CR := CRRecordByMats( G, mats );
    cc := TwoCohomologyCR(CR);
    l := Length(cc.factor.rels);
    Print(" cent ext with dim ",l,"\n");
    v := NormedVectors(GF(p)^l);
    ext := [];
    for i in [1..Length(v)] do
        H := ExtensionCR( CR, IntVector( v[i]*cc.factor.prei ) );
        if Index(H, DerivedSubgroup(H)) = p^2 and 
           IsAbelian(DerivedSubgroup(H)) and
           Index(H, Centralizer(H, UpperCentralSeries(H)[1])) <= p then 
            H!.prime := p;
            Add( ext, H );
        fi;
    od;
    return ext;
end;

CentExts := function(p, s)
   local g, G, l, i, j, n, k;
   if p = 2 then 
       G := DihedralPcpGroup(0);
       l := 4;
   else
       G := SpaceGroupByCoclass(p,1,1);
       l := 2;
   fi;
   G!.prime := p;
   g := [[G]];
   for i in [2..s] do
       g[i] := [];
       for j in [1..Length(g[i-1])] do
           G := g[i-1][j];
           n := ReducedCentralExtensions( G );
           n := DistinguishGroups(n, p, l*p*i);
           for k in [1..Length(n)] do n[k]!.parent := j; od;
           Append(g[i], n);
           Print("group ",j, " at layer ",i," has ",Length(n)," exts \n");
       od;
    od;
   return g;
end;

