#############################################################################
##
#W propgrp.gd                  Coclass package                   Bettina Eick
##
## Some general functions for computing with pro-p-groups by coclass.
##

DeclareProperty( "HasFiniteCoclass", IsPcpGroup );
DeclareProperty( "IsCFGroup", IsPcpGroup );
DeclareProperty( "IsECFGroup", IsPcpGroup );
DeclareProperty( "IsSpaceGroup", IsPcpGroup );

DeclareAttribute( "PrimeProPGroup", IsPcpGroup );
DeclareAttribute( "DimensionProPGroup", IsPcpGroup );
DeclareAttribute( "Coclass", IsPcpGroup );
DeclareAttribute( "Parameter", IsPcpGroup );
DeclareAttribute( "LatticeNr", IsPcpGroup );

DeclareAttribute( "HyperCenter", IsPcpGroup );
DeclareAttribute( "PointGroupPre", IsPcpGroup );
DeclareAttribute( "PointGroupLow", IsPcpGroup );
DeclareAttribute( "PointGroup", IsPcpGroup );
DeclareAttribute( "TranslationsPre", IsPcpGroup );
DeclareAttribute( "TranslationsLow", IsPcpGroup );
DeclareAttribute( "Translations", IsPcpGroup );

DeclareAttribute( "CentralExponent", IsPcpGroup );
DeclareAttribute( "EndomorphismDimension", IsPcpGroup );

DeclareOperation( "Cobreadth", [IsPcpGroup] );
DeclareOperation( "CobreadthRandom", [IsPcpGroup] );
DeclareOperation( "CobreadthBound", [IsPcpGroup] );

 

