
#############################################################################
##
#A SchurMultiplicator(G)
##
SchurMult := function(G)
    local C, c, d, f, l;
    
    # cohomology record for trivial module
    C := CRRecordByMats(G, List(Igs(G), x -> IdentityMat(1)));

    # cohomology system
    c := IntTwoCocycleSystemCR(C); 

    # Elementary divisors = Invariants of R/[R,F]
    d := Diag( NormalFormIntMat( TransposedMat(c.base), 1).normal );

    # the torsion part
    f := Collected( Filtered( d, x -> x > 1 ) );

    # subtract R/(R cap F') from the torsion-free part
    l := Length( Filtered( d, x -> x = 0 ) ) - Length(Igs(G)); 

    # this is it
    Add( f, [0,l]); 
    return f;
end;


