
# j in [9,12,15,...]
# k in [j..2*j] (oder 2*j-2)

SkeletonGroupG1 := function( j, k, c, d )
    local Q, i, G, f, g, U;
    Q := SkeletonGroupH0Fp( j, k, c );
    i := PqEpimorphism( Q : Prime := 3, Classbound := k );
    G := Image(i);
    f := GeneratorsOfGroup(Q);
    if d = 1 then 
        g := [f[1], f[2] * f[3]];
    else
        g := [f[1], f[2] * f[3]^-1];
    fi;
    g := List(g, x -> Image(i,x));
    U := Subgroup(G, g);
    return PcGroupWithPcgs(Pcgs(U));
end;

AllSkeletonGroupsG1 := function( j, k )
    local n, G1, G2, H1, H2;
    G1 := SkeletonGroupG1(j, k, 0, 1);
    n := k-j;
    if n = 0 then 
        return [G1];
    elif n <= 9 and (j mod 6) = 0 then 
        return [G1];
    elif n <= 9 then 
        G2 := SkeletonGroupG1(j, k, 0, 2);
        return [G1,G2];
    elif (j mod 6) = 0 then 
        H1 := SkeletonGroupG1( j, k, 1, 1 );
        H2 := SkeletonGroupG1( j, k, 1, 2 );
        return [G1, H1, H2];
    else
        H1 := SkeletonGroupG1( j, k, 1, 1 );
        G2 := SkeletonGroupG1( j, k, 0, 2 );
        H2 := SkeletonGroupG1( j, k, 1, 2 );
        return [G1,H1, G2, H2];
    fi;
end;

# j in [12,15,18,...]
# k in [j..2*j-4]
     
SkeletonGroupG2 := function( j, k, c, d )
    local Q, i, G, f, g, U;
    Q := SkeletonGroupH0Fp( j-3, k+1, c );
    i := PqEpimorphism( Q : Prime := 3, Classbound := k+1 );
    G := Image(i);
    f := GeneratorsOfGroup(Q);
    if d = 1 then 
        g := [f[1], f[2] * f[4]];
    else
        g := [f[1], f[2] * f[4]^-1];
    fi;
    g := List(g, x -> Image(i,x));
    U := Subgroup(G, g);
    return PcGroupWithPcgs(Pcgs(U));
end;

AllSkeletonGroupsG2 := function( j, k )
    local n, G1, G2, H1, H2;
    G1 := SkeletonGroupG2(j, k, 0, 1);
    n := k-j;
    if n = 0 then
        return [G1];
    elif n <= 9 and (j mod 6) = 0 then
        return [G1];
    elif n <= 9 then
        G2 := SkeletonGroupG2(j, k, 0, 2);
        return [G1,G2];
    elif (j mod 6) = 0 then
        H1 := SkeletonGroupG2( j, k, 1, 1 );
        H2 := SkeletonGroupG2( j, k, 1, 2 );
        return [G1, H1, H2];
    else
        H1 := SkeletonGroupG2( j, k, 1, 1 );
        G2 := SkeletonGroupG2( j, k, 0, 2 );
        H2 := SkeletonGroupG2( j, k, 1, 2 );
        return [G1,H1, G2, H2];
    fi;
end;

# j in [12,15,18,...]
# k in [j..2*j-6]
        
SkeletonGroupG0 := function( j, k, c, d )
    local Q, i, G, f, g, U;
    Q := SkeletonGroupH0Fp( j-3, k+2, c );
    i := PqEpimorphism( Q : Prime := 3, Classbound := k+2 );
    G := Image(i);
    f := GeneratorsOfGroup(Q);
    if d = 1 then 
        g := [f[1], f[2] * f[5]];
    else
        g := [f[1], f[2] * f[5]^-1];
    fi;
    g := List(g, x -> Image(i,x));
    U := Subgroup(G, g);
    return PcGroupWithPcgs(Pcgs(U));
end;

AllSkeletonGroupsG0 := function( j, k )
    local n, G1, G2, H1, H2;
    G1 := SkeletonGroupG0(j, k, 0, 1);
    n := k-j;
    if n = 0 then
        return [G1];
    elif n <= 9 and (j mod 6) = 3 then
        return [G1];
    elif n <= 9 then
        G2 := SkeletonGroupG0(j, k, 0, 2);
        return [G1,G2];
    elif (j mod 6) = 3 then
        H1 := SkeletonGroupG0( j, k, 1, 1 );
        H2 := SkeletonGroupG0( j, k, 1, 2 );
        return [G1, H1, H2];
    else
        H1 := SkeletonGroupG0( j, k, 1, 1 );
        G2 := SkeletonGroupG0( j, k, 0, 2 );
        H2 := SkeletonGroupG0( j, k, 1, 2 );
        return [G1,H1, G2, H2];
    fi;
end;

BranchLimitG1 := function(j)
    return j-9; 
end;

BranchLimitG2 := function(j)
    return j-9-5; 
end;

BranchLimitG0 := function(j)
    return j-9-6; 
end;

PrintTwigG0 := function(G, i,j,k)
    local a, b, file, ii, jj, kk;
    ii := String(i);
    jj := String(j);
    kk := String(k);
    file := Concatenation("twigsG/twig0_",ii,"_",jj,"_",kk,".gi");
    PrintTo(file,"TwigG0_",ii,"_",jj,"_",kk," := [\n");
    for a in [1..Length(G)] do
        AppendTo(file,"[");
        for b in [1..Length(G[a])] do
            AppendTo(file,"[",G[a][b][1],",",G[a][b][2],"]");
            if b < Length(G[a]) then
                AppendTo(file,",");
            else
                AppendTo(file,"]");
            fi;
        od;
        if a < Length(G) then
            AppendTo(file,",\n");
        else
            AppendTo(file,"]\n");
        fi;
    od;
    AppendTo(file,";\n\n");
    AppendTo(file,"TWIGG0[",ii,"][",jj,"][",kk,"]:= ");
    AppendTo(file,"TwigG0_",ii,"_",jj,"_",kk,";\n");
    AppendTo("summG.gi", "Add(listG0, [",ii,",",jj,",",kk,"]);\n");
end;

PrintTwigG1 := function(G, i,j,k)
    local a, b, file, ii, jj, kk;
    ii := String(i);
    jj := String(j);
    kk := String(k);
    file := Concatenation("twigsG/twig1_",ii,"_",jj,"_",kk,".gi");
    PrintTo(file,"TwigG1_",ii,"_",jj,"_",kk," := [\n");
    for a in [1..Length(G)] do
        AppendTo(file,"[");
        for b in [1..Length(G[a])] do
            AppendTo(file,"[",G[a][b][1],",",G[a][b][2],"]");
            if b < Length(G[a]) then
                AppendTo(file,",");
            else
                AppendTo(file,"]");
            fi;
        od;
        if a < Length(G) then
            AppendTo(file,",\n");
        else
            AppendTo(file,"]\n");
        fi;
    od;
    AppendTo(file,";\n\n");
    AppendTo(file,"TWIGG1[",ii,"][",jj,"][",kk,"]:= ");
    AppendTo(file,"TwigG1_",ii,"_",jj,"_",kk,";\n");
    AppendTo("summG.gi", "Add(listG1, [",ii,",",jj,",",kk,"]);\n");
end;

PrintTwigG2 := function(G, i,j,k)
    local a, b, file, ii, jj, kk;
    ii := String(i);
    jj := String(j);
    kk := String(k);
    file := Concatenation("twigsG/twig2_",ii,"_",jj,"_",kk,".gi");
    PrintTo(file,"TwigG2_",ii,"_",jj,"_",kk," := [\n");
    for a in [1..Length(G)] do
        AppendTo(file,"[");
        for b in [1..Length(G[a])] do
            AppendTo(file,"[",G[a][b][1],",",G[a][b][2],"]");
            if b < Length(G[a]) then
                AppendTo(file,",");
            else
                AppendTo(file,"]");
            fi;
        od;
        if a < Length(G) then
            AppendTo(file,",\n");
        else
            AppendTo(file,"]\n");
        fi;
    od;
    AppendTo(file,";\n\n");
    AppendTo(file,"TWIGG2[",ii,"][",jj,"][",kk,"]:= ");
    AppendTo(file,"TwigG2_",ii,"_",jj,"_",kk,";\n");
    AppendTo("summG.gi", "Add(listG2, [",ii,",",jj,",",kk,"]);\n");
end;

GetTwigInG1 := function(i, j, k)
    local c, d, G, T, S;

    Print("GetTwigInG1 starts ",[i,j,k]," \n");

    # catch case 
    if (j mod 6) = 0 then  # 3 groups
        if i = 1 then 
            c := 0; d := 1;
        elif i = 2 then 
            c := 1; d := 1;
        elif i = 3 then 
            c := 1; d := 2;
        fi;
    else
        if i = 1 then 
            c := 0; d := 1;
        elif i = 2 then 
            c := 1; d := 1;
        elif i = 3 then 
            c := 0; d := 2;
        elif i = 4 then 
            c := 1; d := 2;
        fi;
    fi;

    if k < BranchLimitG1(j) then 
        G := SkeletonGroupG1( j, j+k+9+1, c, d );
        T := CoclassTree(G, 3, j+k+9, true);
    else
        G := SkeletonGroupG1( j, j+k+9, c, d );
        T := CoclassTree(G, 3, j+k+9, false);
    fi;
    S := TwigCanoForm(T);
    return S;
    PrintTwigG1(S, i, j, k);
end;

GetTwigInG2 := function(i, j, k)
   local c, d, G, T, S;

    Print("GetTwigInG2 starts ",[i,j,k]," \n");

    # catch case
    if (j mod 6) = 0 then  # 3 groups
        if i = 1 then
            c := 0; d := 1;
        elif i = 2 then
            c := 1; d := 1;
        elif i = 3 then
            c := 1; d := 2;
        fi;
    else
        if i = 1 then
            c := 0; d := 1;
        elif i = 2 then
            c := 1; d := 1;
        elif i = 3 then
            c := 0; d := 2;
        elif i = 4 then
            c := 1; d := 2;
        fi;
    fi;

    if k < BranchLimitG2(j) then
        G := SkeletonGroupG2( j, j+k+9+1, c, d );
        T := CoclassTree(G, 3, j+k+9, true);
    else
        G := SkeletonGroupG2( j, j+k+9, c, d );
        T := CoclassTree(G, 3, j+k+9, false);
    fi;
    S := TwigCanoForm(T);
    return S;
    PrintTwigG2(S, i, j, k);
end;

GetTwigInG0 := function(i, j, k)
   local c, d, G, T, S;

    Print("GetTwigInG0 starts ",[i,j,k]," \n");

    # catch case
    if (j mod 6) = 1 then  # 3 groups
        if i = 1 then
            c := 0; d := 1;
        elif i = 2 then
            c := 1; d := 1;
        elif i = 3 then
            c := 1; d := 2;
        fi;
    else
        if i = 1 then
            c := 0; d := 1;
        elif i = 2 then
            c := 1; d := 1;
        elif i = 3 then
            c := 0; d := 2;
        elif i = 4 then
            c := 1; d := 2;
        fi;
    fi;

    if k < BranchLimitG0(j) then
        G := SkeletonGroupG0( j, j+k+9+1, c, d );
        T := CoclassTree(G, 3, j+k+9, true);
    else
        G := SkeletonGroupG0( j, j+k+9, c, d );
        T := CoclassTree(G, 3, j+k+9, false);
    fi;
    S := TwigCanoForm(T);
    return S;
    PrintTwigG0(S, i, j, k);
end;

