
f := CyclotomicPolynomial(Rationals, 9);
K := FieldExtension(Rationals, f);
B := Basis(K);
b := BasisVectors(B);

A := List(b, x -> x*b[2]);
A := List(A, x -> Coefficients(B,x));
Y := [b[4], b[2],b[3], b[2]^6, b[5],b[6]];
Y := List(Y, x -> Coefficients(B,x));
S := [b[1], b[3], b[5], -b[4]-b[1], -b[6]-b[3], b[2]];
S := List(S, x -> Coefficients(B,x));
I := -b;
I := List(I, x -> Coefficients(B,x));

X1 := [b[1], b[2]^4, b[3],b[4], b[2]^7,b[6]];
X1 := List(X1, x -> Coefficients(B,x));
X2 := [b[1],b[2], b[2]^8, b[4],b[5], b[2]^2];
X2 := List(X2, x -> Coefficients(B,x));
U := X1*X2;

#C := Group(A);
#D := Group(A,U);
W := Group(A,Y);
N := Group([A,Y,S,I]);

iso := IsomorphismPcpGroup(W);
WW := Image(iso);
mats := List(Igs(WW), x -> PreImagesRepresentative(iso,x));
WWW := SplitExtensionPcpGroup(WW,mats);

#a := Image(iso, A);
#y := Image(iso, Y);
#b := Image(iso, U);

w := Igs(WWW);
a := w[1];
b := w[2]^2*w[3];
y := w[4];
t0 := w[5];
t1 := Comm(t0,a);
t2 := Comm(t1,a);

R := Subgroup(WWW, [a, t0]);

Hi := [Subgroup(WWW, [a,b,t0]), 
       Subgroup(WWW, [a,b,t1]), 
       Subgroup(WWW, [a,b,t2])];

#DistinguishGroups(Hi,3,10);
# yields: all coclass 3, pairwise non-isom

Gi := [Subgroup(WWW, [a,b*t0]),
       Subgroup(WWW, [a,b*t1]), 
       Subgroup(WWW, [a,b*t2])];

#DistinguishGroups(Gi,3,10);
# yields: all coclass 2, pairwise non-isom

Ni := [Subgroup(WWW, [a,b*t0^-1]),
       Subgroup(WWW, [a,b*t1^-1]), 
       Subgroup(WWW, [a,b*t2^-1])];

#DistinguishGroups(Concatenation(Gi,Ni),3,10);
# yields: all coclass 2, Ni all isom to Gi

Li := [Subgroup(WWW, [a,y*t0]),
       Subgroup(WWW, [a,y*t1]), 
       Subgroup(WWW, [a,y*t2])];

Mi := [Subgroup(WWW, [a,y*a^-1*t0]),
       Subgroup(WWW, [a,y*a^-1*t1]), 
       Subgroup(WWW, [a,y*a^-1*t2])];

#DistinguishGroups(Concatenation(Li,Mi),3,10);
# yields: all coclass 2, pairwise non-isom

#############################################################################
F := FreeGroup(4);
f := GeneratorsOfGroup(F);
a := f[1]; t1 := f[2]; t2 := f[3]; z := f[4];

r := [];
r[1] := [a^3, t1^a/t2^(-1), t2^a / (t1*t2^(-1)),
         t1^(t2)/t1, z^3, z^a/z, z^(t1)/z, z^(t2)/z];

r[2] := [a^3, t1^a/t2^(-1), t2^a / (t1*t2^(-1)*z),
         t1^(t2)/(t1*z^2), z^3, z^a/z, z^(t1)/z, z^(t2)/z];

r[3] := [a^3, t1^a/t2^(-1), t2^a / (t1*t2^(-1)*z),
         t1^(t2)/(t1*z), z^3, z^a/z, z^(t1)/z, z^(t2)/z];

r[4] := [a^3, t1^a/t2^(-1), t2^a / (t1*t2^(-1)*z^2),
         t1^(t2)/t1, z^3, z^a/z, z^(t1)/z, z^(t2)/z];

r[5] := [a^3/z, t1^a/t2^(-1), t2^a / (t1*t2^(-1)),
         t1^(t2)/t1, z^3, z^a/z, z^(t1)/z, z^(t2)/z];

r[6] := [a^3/z, t1^a/t2^(-1), t2^a / (t1*t2^(-1)*z),
         t1^(t2)/(t1*z^2), z^3, z^a/z, z^(t1)/z, z^(t2)/z];


K := List(r, x -> F/x);
Add(K, PcpGroupToFpGroup(R));
Append(K, List(Gi, PcpGroupToFpGroup));
Append(K, List(Li, PcpGroupToFpGroup));
Append(K, List(Mi, PcpGroupToFpGroup));

SplitUp := function(list)
    local i, t, Q, c, S, j, k;
    i := 1;
    t := [[1..Length(list)]];
    while Length(t) < Length(list) do
        i := i+1;
        Q := List(list, x -> NilpotentQuotient(x,i));
        c := List(Q, Coclass);
        S := List(Q, x -> ListPresentation(SPPcpGroup(x, 3, i+3)));
        t := [];
        for j in [1..Length(list)] do
            k := Position(S{[1..j-1]}, S[j]);
            if IsBool(k) then 
                Add(t, [j]);
            else
                k := Position(List(t, x -> x[1]),k);
                Add(t[k], j);
            fi;
        od;
        Print("Level ",i," yields partition ",t," and cc ",c,"\n");
    od;
end;

#############################################################################
#iso2 := IsomorphismPcpGroup(N);
#NN := Image(iso2);
#mats := List(Igs(NN), x -> PreImagesRepresentative(iso2,x));
#NNN := SplitExtensionPcpGroup(NN,mats);

#n := Igs(NNN);
#a := n[3]^2*n[4]^2*n[5];
#b := n[3]*n[4]^2;
#y := n[2]^2*n[3]^2*n[4]^2*n[5]^2;
#s := n[1]*n[3]^2*n[4]^4*n[5];
#i := n[6];
#t0 := n[7];
#t1 := Comm(t0,a);
#t2 := Comm(t1,a);
#t3 := Comm(t2,a);
#t4 := Comm(t3,a);
#t5 := Comm(t4,a);
#t6 := Comm(t5,a);
#
#Gi := [Subgroup(NNN, [a,b*t0]),
#       Subgroup(NNN, [a,b*t1]),
#       Subgroup(NNN, [a,b*t2]),
#       Subgroup(NNN, [a,b*t3]),
#       Subgroup(NNN, [a,b*t4]),
#       Subgroup(NNN, [a,b*t5]),
#];




