
WIDTH := 25;
DEPTH := 40;
SSIZE := [1000,700];

Read("check.gi");
Read("checkG.gi");

PrintVertex := function( Sheet, i, j, t, v )
    local x, y, xx, yy;

    # set up x and y values
    x := 100 + WIDTH * j;
    y := 70  + DEPTH * i;

    # print edge
    Disc( Sheet, x, y, 3 );

    # print line
    xx := 100 + WIDTH * v;
    yy := 70 + DEPTH * (i-1);
    Line( Sheet, xx, yy, x-xx, y-yy );

    if IsInt(t) and t>1 then 
        Text( Sheet, FONTS.small, x+2, y, String(t) );
    fi;
end;

DisplayTwigR := function( i, j, k )
    local T, Title, Sheet, a, b;

    # get twig
    T := TWIG[i][j][k];

    # set up graphic sheet with scale
    Title := Concatenation("twigR-",String(i),"-",String(j),"-",String(k));
    Sheet := GraphicSheet( Title, SSIZE[1], SSIZE[2] );

    # the root
    Disc( Sheet, 100+WIDTH, 70+DEPTH, 3 );

    # the rest
    for a in [2..Length(T)] do
        for b in [1..Length(T[a])] do
            PrintVertex( Sheet, a, b, T[a][b][2], T[a][b][1] );
        od;
    od;
end;

DisplayTwigG1 := function( i, j, k )
    local T, Title, Sheet, a, b;

    # get twig
    T := TWIGG1[i][j][k];

    # set up graphic sheet with scale
    Title := Concatenation("twigG1-",String(i),"-",String(j),"-",String(k));
    Sheet := GraphicSheet( Title, SSIZE[1], SSIZE[2] );

    # the root
    Disc( Sheet, 100+WIDTH, 70+DEPTH, 3 );

    # the rest
    for a in [2..Length(T)] do
        for b in [1..Length(T[a])] do
            PrintVertex( Sheet, a, b, T[a][b][2], T[a][b][1] );
        od;
    od;
end;

DisplayTwigG2 := function( i, j, k )
    local T, Title, Sheet, a, b;

    # get twig
    T := TWIGG2[i][j][k];

    # set up graphic sheet with scale
    Title := Concatenation("twigG2-",String(i),"-",String(j),"-",String(k));
    Sheet := GraphicSheet( Title, SSIZE[1], SSIZE[2] );

    # the root
    Disc( Sheet, 100+WIDTH, 70+DEPTH, 3 );

    # the rest
    for a in [2..Length(T)] do
        for b in [1..Length(T[a])] do
            PrintVertex( Sheet, a, b, T[a][b][2], T[a][b][1] );
        od;
    od;
end;

DisplayTwigG0 := function( i, j, k )
    local T, Title, Sheet, a, b;

    # get twig
    T := TWIGG0[i][j][k];

    # set up graphic sheet with scale
    Title := Concatenation("twigG0-",String(i),"-",String(j),"-",String(k));
    Sheet := GraphicSheet( Title, SSIZE[1], SSIZE[2] );

    # the root
    Disc( Sheet, 100+WIDTH, 70+DEPTH, 3 );

    # the rest
    for a in [2..Length(T)] do
        for b in [1..Length(T[a])] do
            PrintVertex( Sheet, a, b, T[a][b][2], T[a][b][1] );
        od;
    od;
end;

