#############################################################################
## 
#W  read.gi                   Package Coclass                    Bettina Eick
##

##
## library of pro-p-groups
##
ReadPkg("coclass", "gap/library/prime2.gi");
ReadPkg("coclass", "gap/library/prime3.gi");
ReadPkg("coclass", "gap/library/prime5.gi");
ReadPkg("coclass", "gap/library/library.gi");
ReadPkg("coclass", "gap/library/maxclass.gi");

##
## working with pro-p-groups
##
ReadPkg("coclass", "gap/propgrp/propgrp.gi"); 
ReadPkg("coclass", "gap/propgrp/matrix.gi"); 
ReadPkg("coclass", "gap/propgrp/intcohom.gi");
ReadPkg("coclass", "gap/propgrp/schur.gi");
ReadPkg("coclass", "gap/propgrp/cobreadth.gi"); 

##
## classification of integral pro-p-groups
##
if not IsBound( TRANSLATE ) then TRANSLATE := false; fi;  # return groups
if not IsBound( TRANSCODE ) then TRANSCODE := false; fi;  # return codes
if not IsBound( COUNTONLY ) then COUNTONLY := false; fi;  # count grps only
if not IsBound( COVEREDGP ) then COVEREDGP := false; fi;  # covered grps
if not IsBound( SPLITONLY ) then SPLITONLY := false; fi;  # split ext only

ReadPkg("coclass", "gap/classify/general.gi");     ## general stuff
ReadPkg("coclass", "gap/classify/pcpgrp.gi");      ## general/ pcp groups
ReadPkg("coclass", "gap/classify/matgrp.gi");      ## general/ mat groups
ReadPkg("coclass", "gap/classify/pcpmat.gi");      ## convert mat -> pcp
ReadPkg("coclass", "gap/classify/pointgrps.gi");   ## W_i(s)
ReadPkg("coclass", "gap/classify/pointcent.gi");   ## C_i(s)
ReadPkg("coclass", "gap/classify/pointnorm.gi");   ## N_i(s)
ReadPkg("coclass", "gap/classify/uniserial.gi");   ## uniserial subgroups
ReadPkg("coclass", "gap/classify/actions.gi");     ## lattices and actions
ReadPkg("coclass", "gap/classify/system.gi");      ## some stuff for cohom
ReadPkg("coclass", "gap/classify/cohomgen.gi");    ## cohomology
ReadPkg("coclass", "gap/classify/cohomred.gi");    ## cohomology
ReadPkg("coclass", "gap/classify/grpext.gi");      ## group extensions
ReadPkg("coclass", "gap/classify/spacegrp.gi");    ## classify space groups
ReadPkg("coclass", "gap/classify/disting.gi");     ## distinguish by factors
ReadPkg("coclass", "gap/classify/centext.gi");     ## classify central exts

##
## special types of pro-p-groups
##
ReadPkg("coclass", "gap/classify/cfgroups.gi");    ## cf group examples
ReadPkg("coclass", "gap/classify/cobreadth.gi");   ## class-breadth examples

##
## tree investigations
##
XAV := RequirePackage("xgap");                           
if XAV=true then 
    ReadPkg("coclass", "gap/trees/tcano.gi"); 
    ReadPkg("coclass", "gap/trees/xtree.gi"); 
    ReadPkg("coclass", "gap/trees/xmeta.gi"); 
fi;

